package se.chalmers.cs.gf.tramdemo;

import java.awt.Point;
import java.util.*;

import se.chalmers.cs.gf.util.Pair;
import static se.chalmers.cs.gf.util.Pair.pair;

public class CoordMap<A> {

        private List<Pair<Point,A>> points;

        private double threshold;

        public CoordMap(double threshold) {
                this.points = new ArrayList<Pair<Point,A>>();
                this.threshold = threshold;
        }

        // FIXME: would like more efficient implementation
        // this is linear in the number of points
        public List<A> get(Point p) {
                List<A> rs = new LinkedList<A>();
                for (Pair<Point,A> x : points)
                        if (p.distance(x.fst) < threshold)
                                rs.add(x.snd);
                return rs;
        }

        public void add(Point p, A value) {
                points.add(pair(p,value));
        }

        public void add(int x, int y, A value) {
                add(new Point(x,y), value);
        }

}
